#include <pthread.h>
#include <stdio.h>
#include <stdlib.h>
#include <time.h>

#define NTHREADS      4
#define ARRAYSIZE   1000000
#define ITERATIONS   ARRAYSIZE / NTHREADS

double  sum=0.0, tSum= 0.0, arr[ARRAYSIZE];
pthread_mutex_t sum_mutex;


void *do_work(void *tid) {
	int i, start, *mytid, end;
	double mysum=0.0;

	/* Initialize my part of the global array and keep local sum */
	mytid = (int *) tid;
	start = (*mytid * ITERATIONS);
	end = start + ITERATIONS;
	printf ("Thread %d doing iterations %d to %d\n",*mytid,start,end-1); 
	for (i=start; i < end ; i++) {
		mysum = mysum + arr[i];
	}

	/* Lock the mutex and update the global sum, then exit */
	pthread_mutex_lock (&sum_mutex);
	tSum = tSum + mysum;
	pthread_mutex_unlock (&sum_mutex);
	pthread_exit(NULL);
}




int main(int argc, char *argv[]) {
	
	int i, start, tids[NTHREADS];
	pthread_t threads[NTHREADS];
	
	for(i = 0; i < ARRAYSIZE; i++){
		arr[i] = rand() % 11;
	}
	
	// Pthreads setup: initialize mutex Pass each thread its loop offset
	pthread_mutex_init(&sum_mutex, NULL);
	for (i=0; i<NTHREADS; i++) {
		tids[i] = i;
		pthread_create(&threads[i], NULL, do_work, (void *) &tids[i]);
    }
	
	//local sum to check result
	sum=0.0;
	for (i=0;i<ARRAYSIZE;i++){ 
		sum = sum + arr[i];
	}
	printf("Check Sum = %e\n",sum);
	

	/* Wait for all threads to complete then print global sum */ 
	for (i=0; i<NTHREADS; i++) {
		pthread_join(threads[i], NULL);
	}
	printf ("Threaded Sum = %e \n", tSum);
	
	int x = sum == tSum;
	printf("sum == tSum: %s\n", x ? "true" : "false");

	/* Clean up and exit */
	pthread_mutex_destroy(&sum_mutex);
	pthread_exit (NULL);
}